unit SpotLabel;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls;

type
  TSpotLabel = class(TLabel)
  private
    MouseInArea: boolean;
    FNormColor,
    FSpotColor : TColor;
    procedure CMMouseEnter(var Message: TMessage); message CM_MOUSEENTER;
    procedure CMMouseLeave(var Message: TMessage); message CM_MOUSELEAVE;
  protected
    procedure Paint; override;
  public
    constructor Create(AOwner: TComponent); override;
  published
    property NormalColor: TColor read FNormColor write FNormColor;
    property SpotColor: TColor read FSpotColor write FSpotColor;
  end;

procedure Register;

implementation

procedure Register;
begin
  RegisterComponents('David Library', [TSpotLabel]);
end;

procedure TSpotLabel.Paint;
begin
 if MouseInArea then
    Font.Color := FSpotColor
 else
    Font.Color := FNormColor;
 inherited Paint;
end;

procedure TSpotLabel.CMMouseEnter;
begin
 MouseInArea := true;
 Invalidate;
end;

procedure TSpotLabel.CMMouseLeave;
begin
 MouseInArea := false;
 Invalidate;
end;

constructor TSpotLabel.Create(AOwner: TComponent);
begin
 inherited Create(AOwner);
 NormalColor := Font.Color;
 SpotColor := clBlue;
end;

end.
